' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank Black                        
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'  BEGINNER'S ADVENTURES INTRO PROGRAM      Update: 10 OCT 2000  
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ

DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)
DECLARE SUB SkullRV (sk1, sk2, sk3, sk4, sk5, sk6)
DECLARE SUB HRT ()

TYPE RECORD
  CNAME AS STRING * 40: Status AS INTEGER: a1 AS INTEGER: A2 AS INTEGER
  A3 AS INTEGER: SP1 AS INTEGER: SP2 AS INTEGER: SP3 AS INTEGER
  SP4 AS INTEGER: WA1 AS INTEGER: WA2 AS INTEGER: WA3 AS INTEGER
  WA4 AS INTEGER: WA5 AS INTEGER: AE AS INTEGER: sex AS INTEGER: gold AS LONG
  bank AS LONG: ac AS INTEGER: WN1 AS STRING * 20: WN2 AS STRING * 20
  WN3 AS STRING * 20: WN4 AS STRING * 20: WCOMPLX1 AS INTEGER
  WCOMPLX2 AS INTEGER: WCOMPLX3 AS INTEGER: WCOMPLX4 AS INTEGER
  WTYPE1 AS INTEGER: WTYPE2 AS INTEGER: WTYPE3 AS INTEGER: WTYPE4 AS INTEGER
  WDICE1 AS INTEGER: WDICE2 AS INTEGER: WDICE3 AS INTEGER: WDICE4 AS INTEGER
  WSIDES1 AS INTEGER: WSIDES2 AS INTEGER: WSIDES3 AS INTEGER
  WSIDES4 AS INTEGER
END TYPE
DIM Z AS RECORD

'
' Make sure graphic mode is available for Alt. Beg. Cave intro
'
ON ERROR GOTO ScreenError: SCREEN 7
CaveTest:
ON ERROR GOTO 0: SCREEN 0: WIDTH 80

RESTORE AdventureData: READ a
DIM SHARED a$(a), a1$(a), mp$(a), dly#, CC1#, CC2#, CC3#, adv, adv1, adv2
OPEN "..\SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE
OPEN "NEW-MEAT" FOR RANDOM AS #1 LEN = 200: GET #1, 1, Z: CLOSE
name$ = LTRIM$(RTRIM$(Z.CNAME$)): sex = Z.sex: q$ = CHR$(34)

adv2 = a
FOR a = 1 TO adv2
   READ a$(a), a1$(a), mp$(a): a1$(a) = "by " + a1$(a)
NEXT
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) + CHR$(32) + CHR$(27)  '(Enter, Space, Escape)
DIM SHARED ANAME$, dungeons
OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, c, c, c, c, ANAME$, c, c, dungeons
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT: CLOSE
END IF

'    Initialize drawing coordinate strings for HRT sub  (Hi-Res Text)
DIM SHARED ab$(255), a$, col, row, TextSize, TextColor1, TextColor2
RESTORE HRTstrings: FOR a = 33 TO 90: READ ab$(a): NEXT

l$ = STRING$(80, 196)
OPEN "GAMEDIR.DAT" FOR INPUT AS #1: INPUT #1, a: CLOSE
author1$ = "Compiled by Frank Black"
adventure1$ = "Beginner's Adventures"
author$ = author1$: adventure$ = adventure1$

COLOR 3: GOSUB Title
IF ASC(MID$(name$, 1)) = 0 THEN
  CLS : PRINT "!! WARNING !!": PRINT
  PRINT "This adventure has a corrupted file.  File is being restored and you are"
  PRINT "being returned to the main menu.": PRINT : PRINT : GOSUB KeyWait
  OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1
  PRINT #1, -1
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT
  CLOSE : CHDIR "..": RUN "EAMONDX"
END IF

IF a = -1 THEN
  a = -2: OPEN "GAMEDIR.DAT" FOR OUTPUT AS #1: PRINT #1, a
  FOR m = 1 TO 5
     PRINT #1, "(none)"
  NEXT: CLOSE
END IF

IF a = -2 THEN GOTO Intro
OPEN "ADV.DAT" FOR INPUT AS #1: INPUT #1, adv1: CLOSE
adv = adv1: adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
PRINT "Welcome back to "; adventure$; "!": PRINT
PRINT "Do you want to see the intro story again? (Y/N):"; : GOSUB KeyWait1
IF k$ <> "y" AND k$ <> "Y" THEN GOTO IntroDone
ON adv GOSUB Cave, Demo, AltCave, Forest, CaveII, EnhancedCave
GOTO IntroDone

'              First-time intro
'             ------------------
Intro:
GOSUB Title
a$ = "This is official Eamon Deluxe adventure #1": GOSUB Center
PRINT : COLOR 2
a$ = "WELCOME TO THE BEGINNER'S ADVENTURES COLLECTION!": GOSUB Center
PRINT : COLOR 3
PRINT "I have compiled here all of the classic adventures with a "; q$; "beginner's"; q$; " theme"
PRINT "from the Apple II Eamon system, as well as a demonstration adventure I wrote to"
PRINT "initially test and develop the Eamon Deluxe system.  With the exception of the"
PRINT "Demo Adventure, they were all intended for beginning level characters."
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT "NOTE:": COLOR 3: PRINT
PRINT "You should read through your Player's Manual before you start adventuring, as it"
PRINT "has a detailed explanation of all the commands.  If you are familiar with other"
PRINT "versions of Eamon, you'll still want to glance through it because Eamon Deluxe"
PRINT "has many significant features."
PRINT
PRINT "All manuals can be read (or printed to hard copy) from the main Eamon Deluxe"
PRINT "menu.  I hope you enjoy this collection of simple forays."
PRINT
PRINT SPC(43); "--Frank Black, October 2000"
PRINT : PRINT : GOSUB KeyWait

Menu:
author$ = author1$: adventure$ = adventure1$: GOSUB Title
COLOR 2
FOR a = 1 TO 3
   PRINT a$(a); : LOCATE CSRLIN, 40: PRINT a$(a + 3)
NEXT
PRINT : COLOR 3: k = 10: c1 = 4
CALL EDXMenuM(k, c1, 1, 4, 3, 0)
IF k < 1 OR k > 4 THEN GOTO Menu
IF k = 4 THEN CHDIR "..": RUN "EAMONDX"

GOSUB Pick
ON k GOTO Stories, Reviews, IntroDone0

Stories:
GOSUB Title
ON adv GOSUB Cave, Demo, AltCave, Forest, CaveII, EnhancedCave
GOTO Menu

Reviews:
GOSUB Title
ON adv GOSUB Cave1, Demo1, AltCave1, Forest1, CaveII1, EnhancedCave1
GOTO Menu

IntroDone0:
GOSUB Title
ON adv GOSUB Cave, Demo, AltCave, Forest, CaveII, EnhancedCave
IntroDone:
IF adv <> 3 THEN PRINT "(Waking up the monsters...)"
IF adv = 3 THEN PRINT "(Please wait while I stir things up...)"
OPEN "ADV.DAT" FOR OUTPUT AS #1: PRINT #1, adv: CLOSE
RUN mp$

'              ---------------------
'               The Beginner's Cave
'              ---------------------
Cave:
GOSUB Title
PRINT "The Beginner's Cave has been set up by the Warlord as a service to all Free"
PRINT "Adventurers, giving them a chance to try their skills in a not-too-dangerous"
PRINT "setting.  Let us all toast the Warlord for restocking the cave daily!"
PRINT
PRINT "Only beginner's are supposed to enter the cave (but any character can).  Knight"
PRINT "Marshall William Misslefire is on duty to prevent you from doing anything"
PRINT "really stupid (like entering the cave with no weapon at all!)."
PRINT
PRINT "To return to the Main Hall, just leave the cave (by getting to the cave entrance"
PRINT "and moving north).  Once you have done so, Sam Slicker (the local dealer for"
PRINT "treasures and booty) will pay you what they are worth (with the price adjusted"
PRINT "slightly by your charisma)."
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT "NOTES:": COLOR 3: PRINT
PRINT "This is the true and original Beginner's Cave and actually the first Classic"
PRINT "Eamon adventure, written by Don Brown nearly two decades ago.  I added nothing"
PRINT "new and only made the changes needed for Eamon Deluxe conversion.  The only"
PRINT "real "; q$; "enhancement"; q$; " of mine is that ALL characters may now enter, whereas the"
PRINT "original only allowed new characters generated by the Main Hall."
PRINT : PRINT SPC(60); "-FK"
PRINT : PRINT : GOTO KeyWait
Cave1:
GOSUB Title
PRINT "No reviews presently exist for "; q$; "The Beginner's Cave"; q$; "."
PRINT : PRINT : GOTO KeyWait
'
'        ---------------------------------
'         The Eamon Deluxe Demo Adventure
'        ---------------------------------
Demo:
GOSUB Title
PRINT "The Eamon Deluxe Demo Adventure is a very small little dungeon with no special"
PRINT "programming (other than the basic mods that allow it to share the database with"
PRINT "the other adventures) that I've used to test the base dungeon program while"
PRINT "developing the Eamon Deluxe system."
PRINT
PRINT "The story is, you were wandering through the woods when you heard somebody cry"
PRINT "out.  You head in the direction which the sounds came from and come upon a small"
PRINT "house in the middle of the woods.  Standing outside are two other members of the"
PRINT "Free Adventurer's Guild.  Not being weak on courage, you decide to explore the"
PRINT "house."
PRINT : PRINT : GOTO KeyWait
Demo1:
GOSUB Title
PRINT "This an Eamon Deluxe original adventure and therefore has not been reviewed."
PRINT : PRINT : GOTO KeyWait
'
'            ---------------------------
'             Alternate Beginner's Cave
'            ---------------------------
AltCave:
IF CaveTest = 0 THEN
  SCREEN 7
  CALL SkullRV(15, 15, 4, 0, 14, 0): CALL SkullRV(0, -1, -1, -1, -1, -1)
  col = 1: row = 4: TextSize = 1: TextColor1 = 3: TextColor2 = -1
  a$ = "YOU ARE ABOUT TO": CALL HRT: a$ = "ADVENTURE IN THE": CALL HRT
  col = 1: row = 5: TextSize = 2: TextColor1 = 2: TextColor2 = 0
  a$ = "ALTERNATE": CALL HRT:  a$ = "BEGINNER'S": CALL HRT: a$ = "  CAVE": CALL HRT
  col = 1: row = 24: TextSize = 1: TextColor1 = 7: TextColor2 = -1
  a$ = "CONVERTED TO EAMON": CALL HRT: a$ = "DELUXE BY FRANK BLACK": CALL HRT
  a$ = "GRAPHIC CONVERSION": CALL HRT: a$ = "BY RAQUEL JOHNSON": CALL HRT
  a$ = INKEY$
  FOR x# = 1 TO dly# * 30
     IF INKEY$ <> "" THEN x# = dly# * 30
  NEXT
  SCREEN 0: WIDTH 80: CLS : COLOR 3: GOSUB Title
END IF
GOSUB Title
PRINT "There is no introduction to this adventure, you simply wander about a different"
PRINT "Beginner's Cave."
PRINT : PRINT : GOTO KeyWait
AltCave1:
s$ = "March 1996": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski"
PRINT
PRINT "Playing Time: 30 min."
PRINT "Reviewer Rating: 5.0    Average Rating: 5.0/6"
PRINT
PRINT "Comment:  This is a very adequate adventure for beginners and young Eamonauts."
PRINT "It has 46 rooms, one secret passage, one hidden treasure, one container, one"
PRINT "magic potion, and one maiden to rescue.  I encountered no death traps.  The"
PRINT "monsters were pushovers with my magic sword.  There were a couple of nice"
PRINT "special effects with monsters appearing in the room.  Overall, a good job, "
PRINT "considering the target audience."
PRINT : PRINT : GOTO KeyWait
'
'            -----------------------
'             The Beginner's Forest
'            -----------------------
Forest:
GOSUB Title
PRINT "You have no trouble finding a horse that you, well, borrow to take you on your"
PRINT "first adventure.  You follow several signs to take you to the Beginner's Forest."
PRINT
PRINT "You see a green, vine covered arch and a locked gate under the arch.  The gate"
PRINT "is wrought iron, into the design is worked the letters "; q$; "Beginner's Only"; q$; "."
PRINT
PRINT "As you stand there, you see the local Knight Marshal come out to inspect you."
PRINT
IF LTRIM$(RTRIM$(Z.WN1$)) = "" OR LTRIM$(RTRIM$(Z.WN1$)) = "NONE" THEN
  PRINT "He shakes his head and says, "; q$; "You really should have at least one weapon to"
  PRINT "adventure here!"; q$: PRINT
END IF
IF Z.AE > 0 OR Z.WA1 <> 5 OR Z.WA2 > -10 OR Z.WA3 <> 20 OR Z.WA5 <> 0 THEN
  PRINT "He shakes his head and says, "; q$; "You are not a beginner!  You shouldn't be here!"; q$: PRINT
END IF
PRINT "Eventually he says, "; q$; "You may proceed."; q$; "  He then unlocks the gate and walks away."
PRINT : PRINT : GOTO KeyWait
Forest1:
s$ = "March 1998": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 10-60 min.": PRINT "Reviewer Rating: 5.0": PRINT
PRINT "Comment: As the above implies, this Eamon is designed for beginner characters,"
PRINT "just like the "; q$; "Beginners Cave"; q$; ".  I whomped up a new character, bought myself a"
PRINT "sword and leather armor, and jumped right in."
PRINT
PRINT "It is well enough written, with a small, coherent map and good descriptions. It"
PRINT "is heavy into combat, and is pretty tough for freshly minted characters with"
PRINT "very little in the way of weapons, armor, and spells. I got killed out five or"
PRINT "six times in 20 minutes of playing, and never did see more than about 20 of the"
PRINT "32 rooms. In fact, I am going to jump up the difficulty rating to (7) because I"
PRINT "found it darned hard to survive the combat with a brand-new character."
PRINT
PRINT "One hint: don't even try to fight the spooks; you'll soon find yourself"
PRINT "hopelessly outnumbered. Run away!"
PRINT : PRINT : GOTO KeyWait
'
'            ------------------------
'             The Beginner's Cave II
'            ------------------------
CaveII:
GOSUB Title
PRINT "This is a Beginner's Cave that John Nelson wrote for the aborted "; q$; "Eamon II"; q$
PRINT "project.  It was translated into a standard Apple II Eamon format by Tom"
PRINT "Zuchowski.  It was then converted to Eamon Deluxe by Frank Black."
PRINT
PRINT "Note that this is a beginner's adventure and is small in size and comparatively"
PRINT "simple in construction."
PRINT
PRINT "The Beginner's Cave has been set up by the Warlord as a service to all Free"
PRINT "Adventurers, giving them a chance to try their skills in a not-too-dangerous"
PRINT "setting."
PRINT
PRINT "Let us all toast the Warlord for restocking the cave daily!"
PRINT : PRINT : GOTO KeyWait
CaveII1:
s$ = "June 1990": GOSUB Review1
PRINT "Reviewed by Starshine": PRINT
PRINT "Playing Time: 1 hour": PRINT "Reviewer Rating: 1.0    Average Rating: 2.0/2"
PRINT
PRINT "Comment: With John Nelson as author, I was expecting an improvement over the"
PRINT "original Beginner's Cave but was disappointed.  The monsters in the cave"
PRINT "consisted of the usual rat, troll, and snake, but the wild boar and bull were"
PRINT "out of place in a cave.  'Treasure' was misspelled.  The action was dull with no"
PRINT "exciting Trollsfire type weapons or hidden surprises.  The treasures were"
PRINT "give-aways with little hazard for the taking.  The original Beginner's Cave"
PRINT "remains the better of the two for me."
PRINT : PRINT : GOTO KeyWait
'
'            --------------------------
'             Enhanced Beginner's Cave
'            --------------------------
EnhancedCave:
GOSUB Title
PRINT "The Beginner's Cave has been set up by the Warlord as a service to all Free"
PRINT "Adventurers, giving them a chance to try their skills in a not-too-dangerous"
PRINT "setting.  Let us all toast the Warlord for restocking the cave daily!"
PRINT
PRINT "Only beginner's are supposed to enter the cave (but any character can).  Knight"
PRINT "Marshall William Misslefire is on duty to prevent you from doing anything"
PRINT "really stupid (like entering the cave with no weapon at all!)."
PRINT
PRINT "To return to the Main Hall, just leave the cave (by getting to the cave entrance"
PRINT "and moving north).  Once you have done so, Sam Slicker (the local dealer for"
PRINT "treasures and booty) will pay you what they are worth (with the price adjusted"
PRINT "slightly by your charisma)."
PRINT : PRINT : GOSUB KeyWait
COLOR 2: PRINT "Notes:": COLOR 3: PRINT
PRINT "This adventure is identical to the "; q$; "Beginner's Cave"; q$; " except that John Nelson"
PRINT "added some new rooms, monsters, etc.  There is also one new secret passage to"
PRINT "find.  For those who may be curious, it uses the same MAINPGM as the Beginner's"
PRINT "Cave (BEGCAVE.BAS), although it does have its own separate database.  I'd say "
PRINT "that roughly 1/3 of the stuff is new."
PRINT : PRINT : GOTO KeyWait
EnhancedCave1:
s$ = "March 1990": GOSUB Review1
PRINT "Reviewed by Tom Zuchowski": PRINT
PRINT "Playing Time: 30 minutes": PRINT "Reviewer Rating: 5.0"
PRINT
PRINT "Comment: I thought long and hard before assigning this adventure its own number,"
PRINT "but one-third of the database is new and it has a completely new MAIN PGM, and"
PRINT "in the end it seemed that it would be easier to track bugs and revisions if it"
PRINT "was listed separately."
PRINT
PRINT "If you have seen the original, you haven't missed much if you haven't seen this"
PRINT "one.  It is after all an adventure for beginners and is very simple. The rating"
PRINT "reflects this; if it was judged as a normal adventure it would not rate quite as"
PRINT "well.  I give it a (3) for difficulty."
PRINT : PRINT : GOTO KeyWait
'                *****************
'                  Review header
'                *****************
Review1:
GOSUB Title: COLOR 2: PRINT "The Eamon Adventurer's Guild"
PRINT "Thomas Zuchowski, Editor": PRINT "7625 Hawkhaven Dr."
PRINT "Clemmons, NC  27012": COLOR 3: PRINT : PRINT
PRINT "The following is from the "; s$; " issue of the Eamon Adventurer's Guild"
PRINT "newsletter.  The EAG supports the Apple II version of Eamon and not Eamon"
PRINT "Deluxe.  The review is for the old Apple II version.": PRINT
PRINT "The EAG rating system is from 1-10 (10 being the best), the average rating"
PRINT "is displayed with the number of people who have rated it.  e.g. 4.6/3 is an"
PRINT "average rating of 4.6 by the ratings of three people.": PRINT
PRINT "Remember, these reviews were written for the OLD versions of these adventures,"
PRINT "most Eamon Deluxe adventures have been enhanced considerably!"
PRINT : PRINT : GOTO KeyWait

'                 ********************
'                   Select adventure
'                 ********************
Pick:
adv = 0: a$ = ""
CALL EDX.Select.Multi.Adventure(adv, a$)
adventure$ = a$(adv): mp$ = mp$(adv): author$ = a1$(adv)
RETURN

'               *********************
'                 Wait for keypress
'               *********************
KeyWait:
PRINT "Press any key to continue...";
KeyWait1:
k$ = INKEY$
BS = POS(0): CC# = 0
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/"; : LOCATE CSRLIN, BS
   IF CC# = CC2# THEN PRINT CHR$(179); : LOCATE CSRLIN, BS
   IF CC# = CC3# THEN PRINT "\"; : LOCATE CSRLIN, BS: CC# = 0
   k$ = INKEY$
LOOP UNTIL k$ <> ""

'
' Clear screen and print adventure name and author
'
Title:
CLS : a$ = adventure$: GOSUB Center: a$ = author$: GOSUB Center
PRINT l$: PRINT : RETURN

'
' Center a string on 80-column screen
'
Center:
PRINT SPC(INT((79 - LEN(a$)) / 2)); a$: RETURN

'--------------------------------------------
' Can't initialize graphics screen
'--------------------------------------------
ScreenError:
SCREEN 0: WIDTH 80: CLS : CaveTest = 1
COLOR 0, 2: PRINT " Sorry, ": COLOR 3, 0: PRINT
PRINT "You won't be able see the graphic intro screen for the "; q$; "Alternate Beginner's"
PRINT "Cave"; q$; ", because it requires an EGA or VGA graphics display."
PRINT : PRINT : GOSUB KeyWait: RESUME CaveTest


'
' Adventure data
'
AdventureData:
DATA 6
DATA The Beginner's Cave,Donald Brown,BEGCAVE
DATA Eamon Deluxe Demo Adventure,Frank Black,MAINPGM
DATA Alternate Beginner's Cave,Rick Volberding,ALTCAVE
DATA Beginner's Forest,Margaret Anderson,FOREST
DATA Beginner's Cave II,John Nelson,CAVEII
DATA Enhanced Beginner's Cave,Donald Brown & John Nelson,BEGCAVE

EDXMenuStrings:
DATA 4
DATA " 1. Read intro stories "," 2. Read adventure reviews "
DATA " 3. Play an adventure "," 4. Quit "

'  DRAW strings for HRT routine
HRTstrings:
DATA br1d2r1bd2l1r1bu2u2l1,"","","","","",bd2e1u1,"","","","",bd4e1u1,""
DATA bd3f1u1d1l1e1l1d1,"","","","","","","","","","","","",bd5e1u1bu2u1,""
DATA bd1r3bd2l3,"",bd4br1r1bu2e1h1l1,""
DATA bf1d3br2u2l2u1e1f1d1,d4r1e1h1e1h1l1,br2l1g1d2f1r1,d4r1e2h2l1
DATA br1d4r2bu2l2u2r2,r2l2d2r2l2d2,bd1e1r2l2g1d2f1r2u2l1,d4u2r2u2d4,r2l1d4r1l2
DATA bd2d1f1e1u3r1l3,d4u2r1e1u1d1g1f1d1,d4r2,d4u4f2e2d4,d4u4f3d1u4
DATA bd1d2f1r1e1u2h1l1g1,r1f1g1l1d2u4,bd1d2f1r2e1u2h1l2g1bf2f1
DATA d4u2r1f1d1u1h1e1h1l1,br2l1g1f1r1d1g1l1  ,r1d4u4r1,d3f1r1e1u3
DATA d3f1e1u3,d4e2f2u4,d1f2d1u1h1g1d1u1e2u1,d1f1d2u2e1u1,r3g3d1r3

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection
'
'   Codes returned from SUB:
'      c - Number of adventure selected
'     a$ - Name of adventure selected

IF dungeons = 1 THEN c = 1: a$ = ANAME$: EXIT SUB

'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons

keyz$ = CHR$(13) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>                     <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB
END SUB

SUB HRT
'  This is the same SUB that is in the EDXDEMO.BAS file. See that for notes.
HRT:
IF TextSize < 1 THEN TextSize = 1
c = INT(52 / TextSize) + 1
r = INT(26 / TextSize) + 1
IF col > c THEN col = 1: row = row + 1
IF row > r THEN row = 1

DRAW "c" + STR$(TextColor1) + "s" + STR$(TextSize * 4)
IF TextColor2 > -1 THEN GOTO HRT2

FOR a = 1 TO LEN(a$)
   k = ASC(MID$(a$, a, 1))
   DRAW "bm" + STR$((col - 1) * (TextSize * 6) + mode1) + "," + STR$((row - 1) * (TextSize * 7) + mode2)
   DRAW ab$(k): col = col + 1
   IF col > c THEN : col = 1: row = row + 1: IF row > r THEN row = 1
NEXT
col = 1: row = row + 1
EXIT SUB
'
'  Inverse text gets a separate routine because
'    it is slightly slower
'
HRT2:
FOR a = 1 TO LEN(a$)
   k = ASC(MID$(a$, a, 1))
   x = (col - 1) * (TextSize * 6): y = (row - 1) * (TextSize * 7)
   LINE (x, y - 2 * TextSize)-(x + 6 * TextSize, y + 5 * TextSize), TextColor2, BF
   DRAW "c" + STR$(TextColor1)
   DRAW "bm" + STR$((col - 1) * (TextSize * 6) + mode1) + "," + STR$((row - 1) * (TextSize * 7) + mode2)
   DRAW ab$(k): col = col + 1
   IF col > c THEN col = 1: row = row + 1: IF row > r THEN row = 1
NEXT
col = 1: row = row + 1
END SUB

SUB SkullRV (sk1, sk2, sk3, sk4, sk5, sk6)
'                   SkullRV
'   (Based on a picture drawn by Rick Volberding)
'
' Microsoft BASIC conversion, colors, and enhancements
'    by Frank Black.
'(tracy boettcher is a dumb turd with bologna nipples and a hairy stomach)
'
' For sk2 to sk6, a value of -1 means 'don't paint'
'
' sk1 - Skull outline color   sk2 - Skull fill color
' sk3 - Eye socket color      sk4 - Nose socket color
' sk5 - Teeth color           sk6 - Background color

'                  Skull & mouth
Skull:
DRAW "c" + STR$(sk1)
DRAW "bm196,5"
DRAW "r10d1r5d1r5d1r7d1r2d1r2d1r2d1r2d1r2d1r1d1r2d1r2d1r2d1r2d1r1d1"
DRAW "r1d1r2d1r1d1r2d2r1d1r1d2r1d1r1d2r1d1r1d1r1d2r1d2r1d2r1d2r1d2r1d3r1d2r1"
DRAW "d3r1d2r1d10r1d5r1d5r1d5l1d4l1d11l1d3l1d2l1d3l1d2l1d6l1d1l1d1l1d1l1d1l1"
DRAW "d2l1d2l1d1l1d1l1d1l1d1l1d1l1d1l1d1l1d1l1d1l2d1l2d1l5u1l1u1l1u3"
DRAW "r1u2r1u1l3u3l1u2l1u2l1u2l1u2r1u1r1u1l1u1l1u1l5d1l6d1l1d1l1d1l1"
DRAW "d1l1d1l1d1l1d1l15d1l2d1l1d1l2d1l1d1l1u1l1u1l1u1l1u1l1u6l4u1l1u1l5u1"
DRAW "l2u1l1br56bd5d4l1d3l1d3l1d4l1d4l1d3l1d2l1d10l1d3l1d3l1"
DRAW "d3l1d3l1d3l1d1l5d1l5d1l1d1l2d1l2d1l1"
DRAW "d1l2d1l2d1l2d1l2d1l2d1l2d1l2d1l2 "
DRAW "d1l3d1l3d1l3d1l4d1l2d1l3d1l7u1l8u1l10u1l2u4l1u3r1u2r1u2r1u2l1"
DRAW "u2l1u1l1u8l1u1l1r1u3r2"
DRAW "d3l1r2d1r2d1r1d1r1u1r1u3l1u2l1u2l1u2r1d3r1d2r1"
DRAW "d3r1d1r1d1r3u1l1u2l1u7l5r3d1r1d4r1d2r1d2r3u1r1u8l5r4d1bd8r3d1r1u1r1u1 "
DRAW "r1u1r1u1r1u2l1u3l1u1l5r5d2bd4br2r1d1r1d1r1d1u1r1u1r1u1r1u6l5d1l2r2u1r3"
DRAW "d1r1d3r1d2r1d1r1d1u1r1u1r2u1l1r1u5l1u1l3d1br4bd6r4u1r2u1r1u4l6r6d5"
DRAW "r2d1r5u1r1u8l4d1l2d1l2br8d4r3u1r1u1r1u1r1u3l6r6d2r4d1u1r1u1r1u2r1u2r1u5l1"
DRAW "u5r1u5r1u4r1u2r1u2r3u1r2d1r1d1r1d2r2d1"
DRAW "r4u1r1u1r1u1r1u1r1u1r1u1r1u4r4u1r1u1r1"
DRAW "bd34bl36l2u3r1u4l2u1l3d1l1d7u7l3d1l3d1l5u1d1l1d2"
DRAW "l1d5u5r1u2r5d7bl6bu5l1u1l2u1l1d1l1d5u4l1u1l3"
DRAW "d1l1d1l1d5u5l1u2l1u1l1u1l2d3l1d5r1l1u5l1u2l1u1l1d1l1d1l2d6r1l1u7l1u1l2u1"
DRAW "l6d1r2d3l1d2r1d3l1u8l2d3l1d5u7l1u1l1d1l1d7r1u2d4r1u1d7u3r1u4d3r1d4r1u2d3r2"
DRAW "d1r1d1r1bu10l8u3l1u5l1d1"
DRAW "u7l1u2r1u2r1u1r1u2l1u2l1u1l1u1l1u1l1u1l1u1l1u1l1u3l1u2l1u3l1u2l1u3r1"
DRAW "u2r1u5r1u10l1u10r1u5l1u5r1u3r1u2r1u3r1u2r1u3r1u2r1 u4 r1u3r1u2r1u2r1u2"
DRAW "r1u1r1u3r1u2r1u1r1u1r1u1r1u1r1u1r2u2r1u1r1u1r1u1r1u1r2u1r2u1r2u1r2u1"
DRAW "r2u1r3u1r3u1r3u1r3u1r3u1r3u1r3u1r6u1l3r10"
'       Draw eyes & nose
DRAW "bd78bl65 r1l1u2 l1u1l1 u1r1 u1r1u1r1u1r1u1r1u1r2u1r2u1r2d1r2d1r1d1r2d1"
DRAW "r2d6l1d2l2d2l1d2l1d3l1d3r2u1r1u1r1d1r3u1d1r1d2r1d2r1d2r1d1r1d1r1d2r1"
DRAW "d2r1d1r1d6l1d1l1d1l1d1l1d1l1d1l3u1l2u1l2u1d2l1d1u1l1u1l1u3l1u3l1u6r1"
DRAW "u5r1u4l2d2l1d1l2d1l5u1l3u3r1u2r1u2r1u7br34l1u3r1u2r1u1r1u1r1u1r1u1r1"
DRAW "u1r1r2u1r10 d1r1d1r1d1r1d1r2d3r1d2r1d2r1d2r1d1r1d3l1"
DRAW "d4 r1d1l1d1l1d1l1d1l2d1l2d1l3d1l10u1l4u1l1u10l1u3l1u2"

' Paint Skull
IF sk2 > -1 THEN
  DRAW "bm196,8p" + STR$(sk2) + "," + STR$(sk1)
  DRAW "bm220,110p" + STR$(sk2) + "," + STR$(sk1)
  DRAW "bm220,130p" + STR$(sk2) + "," + STR$(sk1)
END IF
' Paint eyes
IF sk3 > -1 THEN
  DRAW "bm140,80p" + STR$(sk3) + "," + STR$(sk1)
  DRAW "bm170,80p" + STR$(sk3) + "," + STR$(sk1)
END IF
' Paint nose
IF sk4 > -1 THEN DRAW "bm148,100p" + STR$(sk4) + "," + STR$(sk1)
' Paint teeth
IF sk5 > -1 THEN
  DRAW "bm137,138p" + STR$(sk5) + "," + STR$(sk1) + "bm141,136p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm148,138p" + STR$(sk5) + "," + STR$(sk1) + "bm153,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm158,138p" + STR$(sk5) + "," + STR$(sk1) + "bm165,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm170,138p" + STR$(sk5) + "," + STR$(sk1) + "bm176,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm184,138p" + STR$(sk5) + "," + STR$(sk1) + "bm189,138p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm141,145p" + STR$(sk5) + "," + STR$(sk1) + "bm147,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm153,148p" + STR$(sk5) + "," + STR$(sk1) + "bm158,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm165,148p" + STR$(sk5) + "," + STR$(sk1) + "bm170,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm177,145p" + STR$(sk5) + "," + STR$(sk1) + "bm184,148p" + STR$(sk5) + "," + STR$(sk1)
  DRAW "bm189,144p" + STR$(sk5) + "," + STR$(sk1)
END IF
' Paint background
IF sk6 > -1 THEN DRAW "bm0,0p" + STR$(sk6) + "," + STR$(sk1)

END SUB

