' THE WONDERFUL WORLD OF EAMON DELUXE ͻ
'                          by Frank Black                        
'                                                                
'         A computerized fantasy role-playing system             
'       based upon the Apple II version by Donald Brown,         
'          John Nelson, Tom Zuchowski, & Frank Black             
'                                                                
'   DUNGEON EDITOR V2                        Update: 14 MAR 2005 
'    by Frank Black                                              
'                                                                
' ALL NON-COMMERCIAL DISTRIBUTION ENCOURAGED ͼ
DECLARE SUB EDX.Select.Adventure (c, a$)
DECLARE SUB EDX.Select.Multi.Adventure (c, a$)
DECLARE SUB EDXMenuM (c, c1, be, en, tc1, tc2)

DECLARE SUB ESelect ()
DECLARE SUB ESelectNo ()
DECLARE SUB GetKey ()
DECLARE SUB NumInput ()
DECLARE SUB TextInput ()

DECLARE SUB ReadRoom ()
DECLARE SUB ReadArtifact ()
DECLARE SUB ReadMonster ()
DECLARE SUB ReadDesc1 ()
DECLARE SUB ReadDesc2 ()
DECLARE SUB ReadDesc3 ()
DECLARE SUB ReadDesc4 ()

DECLARE SUB WriteRoom ()
DECLARE SUB WriteArtifact ()
DECLARE SUB WriteMonster ()
DECLARE SUB WriteDesc1 ()
DECLARE SUB WriteDesc2 ()
DECLARE SUB WriteDesc3 ()
DECLARE SUB WriteDesc4 ()

DECLARE SUB EditRoom ()
DECLARE SUB EditArtifact ()
DECLARE SUB EditMonster ()
DECLARE SUB EditEffect ()

DECLARE SUB DDMenu ()
DECLARE SUB EAdd ()
DECLARE SUB EEdit ()
DECLARE SUB EList ()
DECLARE SUB EDuplicate ()
DECLARE SUB ESpecial ()

'CHDIR "C:\EAMONDX\DD"

ON ERROR GOTO ErrHandler

TYPE adv
   aname AS STRING * 78: NUMBER AS INTEGER
END TYPE
DIM SHARED adv AS adv

DIM SHARED dly#, CC1#, CC2#, CC3#, n%(4), n1%(4), aname$, nd, ver, dungeons
DIM SHARED adj1, adj2, adj3, adj4, columns, clr, nf, mf, a$, c, nw
DIM SHARED c$, ty, pt, na$, lt, no, de$, tl, I$, TextHelp, up, sl, I
DIM SHARED TextHelp1, col, row, csr1, csr2, re, fr, nc, nd1

OPEN "SETTINGS.DAT" FOR INPUT AS #1: INPUT #1, dly#, CC1#, CC2#, CC3#: CLOSE

'
'               Select adventure
'              ------------------
c = 3: a$ = "DD"
CALL EDX.Select.Adventure(c, a$)
IF a$ = "" OR c = 0 THEN
  PRINT "None selected..."; : CALL GetKey
  CHDIR "..": CHDIR "DD": RUN "DDMENU"
END IF
CHDIR "..": CHDIR a$

OPEN "NAME.DAT" FOR INPUT AS #1
INPUT #1, n%(1), n%(2), n%(3), n%(4), aname$, nd, ver, dungeons
FOR x = 1 TO 4: n1%(x) = n%(x): NEXT: nd1 = nd
IF dungeons > 1 THEN
  DIM SHARED dn$(dungeons), dn%(dungeons, 9)
  FOR a = 1 TO dungeons
     LINE INPUT #1, dn$(a): FOR m = 1 TO 9: INPUT #1, dn%(a, m): NEXT
  NEXT: CLOSE
  adj1 = 0: adj2 = 0: adj3 = 0: adj4 = 0
END IF

'
'               Select from multi-adventure database
'              --------------------------------------
IF dungeons > 1 THEN
  c = 0: a$ = ""
  CALL EDX.Select.Multi.Adventure(c, a$)
  n%(1) = dn%(c, 1): n%(2) = dn%(c, 2): n%(3) = dn%(c, 3): n%(4) = dn%(c, 4)
  adj1 = dn%(c, 5) - 1: adj2 = dn%(c, 6) - 1: adj3 = dn%(c, 7) - 1
  adj4 = dn%(c, 8) - 1: nd = dn%(c, 9)
  aname$ = dn$(c)
END IF

'                Initialize data
'               -----------------
TYPE DESC
  TEXT AS STRING * 255
END TYPE
DIM SHARED DS AS DESC

TYPE ROOM
  RNAME AS STRING * 79: d1 AS INTEGER: d2 AS INTEGER: D3 AS INTEGER
  D4 AS INTEGER: D5 AS INTEGER: D6 AS INTEGER: D7 AS INTEGER: D8 AS INTEGER:
  D9 AS INTEGER: D10 AS INTEGER: LIGHT AS INTEGER
END TYPE
DIM SHARED RM AS ROOM

TYPE ARTIFACT
  aname AS STRING * 35: AD1 AS INTEGER: AD2 AS INTEGER: AD3 AS INTEGER:
  AD4 AS INTEGER: AD5 AS INTEGER: AD6 AS INTEGER: AD7 AS INTEGER:
  AD8 AS INTEGER
END TYPE
DIM SHARED ART AS ARTIFACT

TYPE MONSTER
  MNAME AS STRING * 35: MD1 AS INTEGER: MD2 AS INTEGER: MD3 AS INTEGER:
  MD4 AS INTEGER: MD5 AS INTEGER: MD6 AS INTEGER: MD7 AS INTEGER:
  MD8 AS INTEGER: MD9 AS INTEGER: MD10 AS INTEGER: MD11 AS INTEGER
  MD12 AS INTEGER: MD13 AS INTEGER
  END TYPE
DIM SHARED MON AS MONSTER

CLOSE
OPEN "ROOMS.DAT" FOR RANDOM AS #1 LEN = 101
OPEN "ARTIFACT.DAT" FOR RANDOM AS #2 LEN = 51
OPEN "MONSTERS.DAT" FOR RANDOM AS #3 LEN = 61

OPEN "ROOMS.DSC" FOR RANDOM AS #10 LEN = 255
OPEN "ARTIFACT.DSC" FOR RANDOM AS #11 LEN = 255
OPEN "MONSTERS.DSC" FOR RANDOM AS #12 LEN = 255
OPEN "EFFECT.DSC" FOR RANDOM AS #13 LEN = 255

'        Room data
DIM SHARED rd%(11), a%(8), t$(4)
FOR a = 1 TO 4: READ t$(a): NEXT

'        Direction strings
DIM SHARED d$(10)
FOR a = 1 TO 10: READ d$(a): NEXT
columns = 80: clr = 6
'
'        Atrifact data
READ nf: DIM SHARED ty$(nf), f$(nf, 3), df(nf, 3)
FOR a = 0 TO nf
   READ ty$(a)
   FOR a2 = 0 TO 3: READ f$(a, a2), df(a, a2): NEXT
NEXT
'
'        Monster data
mf = 13: DIM SHARED m%(mf), mf$(mf), md(mf)
FOR a = 1 TO mf
   READ mf$(a), md(a)
NEXT

'
'   Initialize choices and exit codes for EDXMenu and EDXMenuM
DIM SHARED em0: RESTORE EDXMenuStrings: READ em0: DIM SHARED em$(em0)
FOR x = 1 TO em0: READ em$(x): NEXT
em$(0) = CHR$(13) '+ CHR$(13) + CHR$(27)  '(Enter, Space, Escape)

'                       -----------
'                        Main menu
'                       -----------
Menu0:
CALL DDMenu: COLOR 3
IF c = 1 THEN CALL EAdd: GOTO Menu0
IF c = 2 THEN CALL EEdit: GOTO Menu0
IF c = 3 THEN CALL EList: GOTO Menu0
IF c = 4 THEN CALL EDuplicate: GOTO Menu0
IF c = 5 THEN CALL ESpecial: GOTO Menu0

'              ------
'               Quit
'              ------
CLOSE
IF up = 1 THEN
   IF dungeons > 1 THEN
     FOR x = 1 TO 4: n%(x) = n1%(x): NEXT: nd = nd1
   END IF
   OPEN "NAME.DAT" FOR OUTPUT AS #1
   PRINT #1, n%(1), n%(2), n%(3), n%(4): PRINT #1, aname$
   PRINT #1, nd, ver, dungeons
   IF dungeons > 1 THEN
     FOR a = 1 TO dungeons
        PRINT #1, dn$(a)
        FOR m = 1 TO 9: PRINT #1, dn%(a, m): NEXT
     NEXT
   END IF
   CLOSE
END IF
CHDIR "..": CHDIR "DD": RUN "DDMENU"



'         ROOM DATA
DATA Room,Artifact,Effect,Monster
DATA N ,S ,E ,W ,U ,D ,NE,NW,SE,SW
'
'       ARTIFACT DATA
DATA 16
DATA Gold,User #5,0,User #6,0,User #7,0,User #8,0
DATA Treasure,User #5,0,User #6,0,User #7,0,User #8,0
DATA Weapon,Odds,10,Type,5,Dice,1,Sides,4
DATA Magic Weapon,Odds,10,Type,5,Dice,1,Sides,10
DATA Container,Key#,0,Open/Closed,0,# of items inside,0,# of items can hold,0
DATA Light,Counter,999,User #6,0,User #7,0,User #8,0
DATA Drinkable,Heal amount,10,# of uses,5,Open/Closed,1,User #8,0
DATA Readable,1st effect,1,# of effects,1,Open/Closed,1,User #8,0
DATA Door/Gate,Room beyond,1,Key#,0,Open/Closed,1,Hidden?,0
DATA Food,Heal amount,10,# of uses,5,Open/Closed,1,User #8,0
DATA Bound monster,Monster#,1,Key #,0,Guard#,0,User #8,0
DATA Wearable,Armor class,0,Type,0,User #7,0,User #8,0
DATA Disguised monster,Monster #,0,# of first effect,0,# of effects,0,User #8,0
DATA Dead body,GET status,0,User #6,0,User #7,0,User #8,0
DATA USER TYPE#1,User #5,0,User #6,0,User #7,0,User #8,0
DATA USER TYPE#2,User #5,0,User #6,0,User #7,0,User #8,0
DATA USER TYPE#3,User #5,0,User #6,0,User #7,0,User #8,0
'
'       MONSTER DATA
DATA Hardiness,16,Agility,16,# Members in group,1,Courage,100,Room,0
DATA Combat Code,0,Armor,0,Weapon #,0,Wep. dice,1,Wep. sides,4
DATA Friendliness,3,User #1,0,User #2,0

EDXMenuStrings:
DATA 20
DATA " 1. Add a new Room, Artifact, Monster or Effect. "
DATA " 2. Edit old Room, Artifact, Monster or Effect. "
DATA " 3. List names of Rooms, Artifacts, Monsters or Effects. "
DATA " 4. Duplicate a Room, Artifact, or Monster. "
DATA " 5. Special functions. "
DATA " 6. Quit. "
'
DATA "  Room      ","  Artifact  ","  Effect    ","  Monster   ","  (Exit)    "
'
DATA "  1. Delete last R, A, E, M  "
DATA "  2. Add to number of R, A, E, M  ","  3. Generate dummy artifacts  "
DATA "  4. Generate dead bodies  ","  5. Turn printer on  "
DATA "  6. (not used)  ","  7. (not used)  ","  8. (not used)  "
DATA "  9. Return to main menu  "

'        ------------
'         Error trap
'        ------------
ErrHandler:
exx = ERR: CLS : COLOR 2, 0: BEEP: PRINT "Uh-oh, a program error just popped up!  (code";
PRINT RTRIM$(STR$(exx)); ")": PRINT
IF exx = 68 OR exx = 25 THEN PRINT "  (Printer not connected)": PRINT
PRINT "Press any key..."; : CALL GetKey
IF exx = 68 OR exx = 25 THEN RESUME Menu0
RESUME ErrHandler1

ErrHandler1:
ON ERROR GOTO 0
CHDIR "..": RUN "EAMONDX"
SYSTEM
END

SUB DDMenu
Menu:
nw = 0: CLS : COLOR 3: PRINT CHR$(218); STRING$(74, 196); CHR$(191)
PRINT CHR$(179); SPACE$(20); "EAMON DELUXE DUNGEON EDITOR  v2.0";
PRINT SPACE$(21); CHR$(179): PRINT CHR$(192); STRING$(74, 196) + CHR$(217)
PRINT : PRINT "  Editing: "; : COLOR 2: PRINT aname$: PRINT : PRINT "  ";
FOR t = 1 TO 4
   COLOR 3: PRINT t$(t); "s"; ":"; : COLOR 2: PRINT n%(t); " ";
NEXT: PRINT : PRINT : PRINT

c = 0: c1 = 6
CALL EDXMenuM(c, c1, 1, 6, 3, 0)
IF c < 1 OR c > 6 THEN GOTO Menu
END SUB

SUB EAdd
'
'            Add stuff
'           -----------
Add:
IF dungeons > 1 THEN
  CLS : COLOR 14: BEEP
  PRINT "This is a multi-adventure database, you can't add anything new to it!"
  COLOR 3: PRINT : PRINT "Hit any key..."; : CALL GetKey: EXIT SUB
END IF
c$ = "add": CALL ESelect: IF ty = 0 THEN EXIT SUB
n%(ty) = n%(ty) + 1
no = n%(ty): re = n%(ty): up = 1: CLS
ON ty GOTO AddRoom, AddArtifact, AddEffect, AddMonster

AddRoom:
na$ = "": de$ = "": lt = 1: FOR a = 1 TO nd: rd%(a) = 0: NEXT
CALL EditRoom: CALL WriteRoom: re = no: CALL WriteDesc1
EXIT SUB

AddArtifact:
na$ = "": de$ = "": nw = 1
CALL EditArtifact: CALL WriteArtifact: re = no: CALL WriteDesc2
EXIT SUB

AddEffect:
de$ = "": CALL EditEffect: re = no: CALL WriteDesc4
EXIT SUB

AddMonster:
na$ = "": de$ = "": FOR a = 1 TO mf: m%(a) = md(a): NEXT
CALL EditMonster: CALL WriteMonster: re = no: CALL WriteDesc3
END SUB

SUB EditArtifact
'
PRINT "Entering Artifact "; no; ".": PRINT
PRINT "Enter Artifact name:": I$ = na$: tl = 35: CALL TextInput

PRINT "Artifact description:"
na$ = I$: I$ = de$: tl = 255: CALL TextInput: de$ = I$

IF nw = 1 THEN a%(1) = 50: a%(2) = 1: a%(3) = 3: a%(4) = 0

a$ = "Value": aa = 1:  GOSUB EdArt: a$ = "Type": aa = 2

xx = INT(nf / 2) + 1
FOR x = 1 TO xx
  PRINT " "; x - 1; " = "; ty$(x - 1);
  IF x - 1 + xx <= nf THEN
     LOCATE CSRLIN, 39 + (ABS(x - 1 + xx < 10))
     PRINT x - 1 + xx; " = "; ty$(x - 1 + xx);
  END IF
  PRINT
NEXT
GOSUB EdArt

a$ = "Weight": aa = 3: q$ = CHR$(34)
PRINT " 999................"; q$; "Don't be absurd!"; q$
PRINT "-999..............."; q$; "You can't get that."; q$: PRINT
GOSUB EdArt

a$ = "Room": aa = 4
PRINT "-1.................Carried by player"
PRINT "(- Monster# - 1)...Monster# carrying it"
PRINT "Artifact# + 1000...Inside Artifact#"
PRINT "Room# + 2000........Embedded in Room#"
PRINT "-999...............Worn by Player"
PRINT "(-1000 -Monster#)..Monster# wearing it": PRINT
GOSUB EdArt

IF a%(2) < 0 OR a%(2) > nf THEN a%(2) = 0
tp = a%(2)

FOR ar = 5 TO 8
   IF nw = 1 THEN a%(ar) = df(tp, ar - 5)
   IF (ar = 7 AND (tp = 6 OR tp = 7 OR tp = 9)) OR (ar = 6 AND tp = 4) THEN
      PRINT "Open = 1;  Closed = 0"
      IF tp = 4 THEN PRINT "1000 + Damage if it must be broken open."
      PRINT
   END IF
   IF (tp = 2 OR tp = 3) AND ar = 6 THEN
      PRINT "1=Axe, 2=Bow, 3=Club, 4=Spear, 5=Sword": PRINT
      PRINT "Guns should be type 2, Knives and daggers should be type 4"
      PRINT
   END IF
   IF tp = 4 AND ar = 8 THEN
     PRINT "0 = Player can't put anything in it": PRINT
   END IF
   IF tp = 5 AND ar = 5 THEN PRINT "-1 = Never runs out": PRINT
   IF tp = 8 AND ar = 6 THEN
     PRINT "-1 = Can never be unlocked or forced open": PRINT
   END IF
   IF tp = 8 AND ar = 7 THEN
     PRINT "Open = 0;  Closed = 1;  100+Damage = Must be forced open": PRINT
   END IF
   IF tp = 8 AND ar = 8 THEN PRINT "1 = Hidden": PRINT
   IF tp = 11 AND ar = 5 THEN
     PRINT "0 = Clothing           4 = Chain mail"
     PRINT "1 = Shield, Helmet     6 = Plate armor"
     PRINT "2 = Leather armor": PRINT
   END IF
   IF tp = 11 AND ar = 6 THEN
     PRINT "0 = Armor, shields       4 = Hats, Headwear"
     PRINT "1 = Overclothes          5 = Jewlery"
     PRINT "2 = Shoes, Boots         6 = Undergarments"
     PRINT "3 = Gloves"
   END IF
   IF tp = 13 AND ar = 5 THEN
     PRINT "1 = Can be taken"
     PRINT "(Should normally be 0)": PRINT
   END IF
   IF tp > nf THEN PRINT "Field #"; ar; ": ";
   IF tp <= nf THEN PRINT f$(tp, ar - 5); ": ";
   I$ = LTRIM$(STR$(a%(ar))): CALL NumInput
   IF INT(VAL(I$)) > 9999 THEN I$ = "9999"
   a%(ar) = INT(VAL(I$))
NEXT
EXIT SUB

EdArt:
PRINT a$; ": "; : I$ = LTRIM$(STR$(a%(aa))): tl = 6: CALL NumInput
a%(aa) = INT(VAL(I$))
RETURN
END SUB

SUB EditEffect
PRINT "Enter Effect #"; no; ":": PRINT
I$ = de$: tl = 255: CALL TextInput: de$ = I$
END SUB

SUB EditMonster
PRINT "Entering Monster #"; no; ":": PRINT
PRINT "** Be sure to enter *ALL* monster names in a singular form **": PRINT
PRINT "Enter name of monster:": I$ = na$: tl = 35: CALL TextInput: na$ = I$

PRINT "Enter description:": I$ = de$: tl = 255: CALL TextInput: de$ = I$

CLS : PRINT "Monster #"; no; "   "; na$: PRINT : GOSUB MonInfo
FOR m = 1 TO mf
   IF m = 3 THEN
     PRINT "   Single Monsters - Enter 1"
     PRINT "   Group Monsters  - Enter # of members"
     PRINT
   END IF
   IF m = 4 THEN
     PRINT "1-100% Chance monster will not flee and follow fleeing player (if enemy)"
     PRINT "If monster is injured fleeing chance is increased 5%"
     PRINT "If monster is near-death fleeing chance is increased 10%"
     PRINT "200% courage will never flee and always follow player": PRINT
   END IF
   IF m = 6 THEN
     PRINT " 1 = Combat text reads '[mon] ATTACKS' only (instead of tear, lunge, etc.)"
     PRINT " 0 = Normal"
     PRINT "-1 = Will use natural weapons when a weapon isn't available"
     PRINT "-2 = Will never fight at all": PRINT
     PRINT "  (should normally be 0)"
   END IF
   IF m = 7 THEN
      GOSUB MonInfo
      PRINT : PRINT "0 = None, 1 = Leather, 2 = Chain, 3 = Plate": PRINT
   END IF
   IF m = 8 THEN
      PRINT "   Artifact #...Weapon"
      PRINT "   0............Natural Weapons"
      PRINT "   -1...........Weaponless"
      PRINT
   END IF
   IF m = 9 THEN
     PRINT "Enter values for monster's natural weapons.": PRINT
   END IF
   IF m = 11 THEN
     PRINT "   1=Enemy  2=Neutral  3=Friend"
     PRINT "For random Friendliness enter percent likely friendly + 100"
     PRINT
   END IF
   PRINT "Enter "; mf$(m); ": ";
   I$ = LTRIM$(STR$(m%(m))): tl = 5: CALL NumInput
   m%(m) = VAL(I$)
NEXT
EXIT SUB

MonInfo:
COLOR 2
PRINT "Weak monsters:  This includes small creatures like rats and kobolds."
PRINT "Medium monsters: Including thugs, orcs, goblins."
PRINT "Tough monsters: Including giants, trained warriors, trolls."
PRINT "Super tough: Such as dragons and demons."
PRINT
PRINT "           Weak       Medium     Tough      Super tough"
PRINT "---------------------------------------------------------"
PRINT "Hardiness:   2-8        9-15     16-30       31-90"
PRINT "Agility  :   5-9       10-16     17-24       25-35"
PRINT "Courage  :  80-90%     95-100%    200%        200%"
PRINT "Armor    :    0         1         2-3         3+"
PRINT "Nat. Damg:   1D4       1D6-1D10  1D10-2D6     2D8+"
PRINT
PRINT "If group monster then enter value for just one member of group."
PRINT : COLOR 3: RETURN
END SUB

SUB EditRoom
CLS : PRINT "Entering room "; no; ".": PRINT
I$ = na$: tl = 79: PRINT "Enter room name:": CALL TextInput
na$ = I$: tl = 255: I$ = de$: PRINT "Enter room Description:"
CALL TextInput: de$ = I$
PRINT "For each direction, enter the room # that this room conects to.": PRINT
PRINT "  No connection:  0": PRINT "  Exit to Main Hall: -999"
PRINT "  Doors: Artifact # of door + 1000"
PRINT "  Negative numbers for unusual things.": PRINT
FOR d = 1 TO nd
   PRINT "Move "; d$(d); ": ";
   I$ = LTRIM$(STR$(rd%(d))): tl = 6
   CALL NumInput
   rd%(d) = INT(VAL(I$))
NEXT
PRINT "Light (0 = Dark; 1 = Light) ";
I$ = LTRIM$(STR$(lt)): CALL NumInput: lt = INT(VAL(I$))
END SUB

SUB EDuplicate
'           Duplicate stuff
'          -----------------
c$ = "Duplicate": CALL ESelect: IF ty = 0 THEN EXIT SUB
IF n%(ty) < 1 THEN EXIT SUB
c$ = "Duplicate from": CALL ESelectNo
fr = no: c$ = "create": CALL ESelectNo
nc = no
IF no <= n%(ty) THEN
  PRINT "Overwrite "; t$(ty); " #"; LTRIM$(RTRIM$(STR$(no)));
  PRINT "?  (Y/N):"; : CALL GetKey: IF a$ <> "Y" THEN EXIT SUB
END IF
CLS : IF no > n%(ty) + 1 THEN no = n%(ty) + 1
IF no > n%(ty) THEN
  IF dungeons > 1 THEN
    CLS : COLOR 14: BEEP
    PRINT "This is a multi-adventure database, you can't add anything new to it!"
    COLOR 3: PRINT : PRINT "Hit any key..."; : CALL GetKey: EXIT SUB
  END IF
  PRINT "Creating a "; t$(ty); " from another."
  n%(ty) = n%(ty) + 1: up = 1
END IF
no = fr
ON ty GOTO DupR, DupA, DupE, DupM

DupR:
CALL ReadDesc1
CALL ReadRoom: re = nc: no = nc
CALL EditRoom: CALL WriteRoom: CALL WriteDesc1: EXIT SUB

DupA:
CALL ReadDesc2
CALL ReadArtifact: re = nc: no = nc
CALL EditArtifact: CALL WriteArtifact: CALL WriteDesc2: EXIT SUB

DupE:
CALL ReadDesc4
re = nc: CALL WriteDesc4: EXIT SUB

DupM:
CALL ReadDesc3
CALL ReadMonster: re = nc: no = nc
CALL EditMonster: CALL WriteMonster: CALL WriteDesc3: EXIT SUB
END SUB

SUB EDX.Select.Adventure (c, a$)
'/// Eamon Deluxe Adventure Selection
'
'   Codes passed to SUB:
'    c=0 - Start from EAMONDX directory
'    c=1 - Back up one directory before starting
'    c=2 - Start from EDX, load designs names also
'    c=3 - Back up one, load designs
'     a$ - Name of directory to return to, if a$ = "" then no return
'          is made
'
'   Codes returned from SUB:
'      c - Number of adventure selected (0=None, -1=Design 1, -2=Design 2)
'     a$ - Name of adventure directory
'
'   Notes:
'     Requires the data type "adv" to be in the main program and
'     it must be dimensioned as SHARED
'

'            Load adventure names
IF c = 1 OR c = 3 THEN CHDIR ".."
OPEN "ADVENTRS" FOR RANDOM AS #2 LEN = 90
   GET #2, 1, adv: numadv = adv.NUMBER: numadv1 = numadv
   REDIM advn$(numadv + 2)
   FOR x = 2 TO numadv + 1
      GET #2, x, adv
      advn$(x - 1) = LEFT$(LTRIM$(RTRIM$(adv.aname$)), 38)
   NEXT
CLOSE

'            Load design names
IF c = 2 OR c = 3 THEN
  CHDIR "dd"
    OPEN "DGNDIR.DAT" FOR INPUT AS #1: INPUT #1, d1, d2: CLOSE
  CHDIR ".."
  IF d1 = 1 THEN
    CHDIR "DGN-1"
      OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, x, x, x, x, k$: CLOSE
      numadv = numadv + 1: advn$(numadv) = LEFT$(k$, 26) + "  (Design 1)"
    CHDIR ".."
  END IF
  IF d2 = 1 THEN
    CHDIR "DGN-2"
      OPEN "NAME.DAT" FOR INPUT AS #1: INPUT #1, x, x, x, x, k$: CLOSE
      numadv = numadv + 1: advn$(numadv) = LEFT$(k$, 26) + "  (Design 2)"
    CHDIR ".."
  END IF
END IF
'             Return to current directory
IF (c = 1 OR c = 3) AND a$ <> "" THEN CHDIR a$

keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

SelectADVa:
GOSUB SelectADV0

SelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB SelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  k$ = LTRIM$(RTRIM$(STR$(c))): a$ = LEFT$("E000", 4 - LEN(k$)) + k$
  IF c = numadv1 + 2 OR (c = numadv1 + 1 AND d1 = 0) THEN a$ = "DGN-2": c = -2
  IF c = numadv1 + 1 THEN a$ = "DGN-1": c = -1
  IF k = 1 THEN c = 0: a$ = ""
  VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO SelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO SelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO SelectADV

'       Set up screen
SelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
COLOR 2, 0: PRINT "Select adventure to edit:": COLOR 7, 1
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0)); : COLOR 3, 0
'       Display choices
SelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDX.Select.Multi.Adventure (c, a$)
'/// Eamon Deluxe Multi-Adventure Selection

IF dungeons = 1 THEN c = 1: a$ = aname$: EXIT SUB

'            Load adventure names
REDIM advn$(dungeons)
FOR x = 1 TO dungeons
   advn$(x) = LEFT$(LTRIM$(RTRIM$(dn$(x))), 38)
NEXT
numadv = dungeons


keyz$ = CHR$(27) + CHR$(13) + CHR$(73) + CHR$(81) + CHR$(71) + CHR$(79)
keyz$ = keyz$ + CHR$(72) + CHR$(80) + CHR$(75) + CHR$(77)
min = VAL(MID$(TIME$, 4, 2)) - 2 '<-- Force time display

mSelectADVa:
GOSUB mSelectADV0

mSelectADV:
IF c < be THEN c = en
IF c > en THEN c = be
x = ABS(c > be + 20): v = 3 + (c - be) - 21 * x: h = 2 + 39 * x
LOCATE v, h: COLOR 0, 3: PRINT advn$(c);

DO
  COLOR 7, 1
  IF VAL(MID$(TIME$, 4, 2)) <> min THEN
    hr = VAL(LEFT$(TIME$, 2)): min = VAL(MID$(TIME$, 4, 2))
    IF (hr = 0 OR hr = 24) AND min = 1 THEN GOSUB mSelectADV0
    k = hr - 12 * ABS(hr > 12) + 12 * ABS(hr = 0): x = 52 - ABS(k > 9)
    LOCATE 25, x: COLOR 7, 1: PRINT SPACE$(13); : LOCATE 25, x
    PRINT "  "; STR$(k);
    PRINT MID$(TIME$, 3); " "; MID$("a.m.p.m.", 4 * ABS(hr > 12) + 1, 4);
  END IF
  LOCATE 25, 60: PRINT RIGHT$(TIME$, 2); : k$ = INKEY$
  k = INSTR(keyz$, RIGHT$(k$, 1)): IF k > 2 THEN k = k * ABS(LEN(k$) > 1)
LOOP UNTIL k$ <> "" AND k > 0

LOCATE v, h: COLOR 3, 0: PRINT advn$(c);

'         Set arguments and exit
IF k < 3 THEN
  a$ = dn$(c): VIEW PRINT 1 TO 25: CLS : EXIT SUB
END IF

'          Pg up/down
IF k = 3 AND be > 1 THEN be = be - 42: GOTO mSelectADVa
IF k = 4 AND en < numadv THEN be = be + 42: GOTO mSelectADVa
'          Home/end
IF k = 5 THEN c = be
IF k = 6 THEN c = en
'         Up/down/left/right
IF k > 8 AND c < be + 21 AND c + 21 > en THEN k = k - 2
IF k = 7 THEN c = c - 1
IF k = 8 THEN c = c + 1
IF k = 9 THEN c = c - 21 + 42 * ABS(c < be + 21)
IF k = 10 THEN c = c + 21 - 42 * ABS(c > be + 21)
GOTO mSelectADV

'       Set up screen
mSelectADV0:
VIEW PRINT 1 TO 25: COLOR 7, 0: CLS : COLOR 7, 1
PRINT "    <Enter=Accept>    <Escape=Exit>    <Page Up/Page Down=More Options>         "
LOCATE 25, 1:
PRINT " <Use Arrow keys, Home, or End to select>"; SPACE$(29);
PRINT MID$(DATE$, 4, 2); "-"; : k = VAL(LEFT$(DATE$, 2)) - 1
PRINT MID$("JanFebMarAprMayJunJulAugSepOctNovDec", k * 3 + 1, 3); "-";
PRINT RIGHT$(DATE$, 2); : PRINT SPACE$(81 - POS(0));
LOCATE 2, 1: COLOR 2, 0: PRINT aname$; ":": COLOR 3
'       Display choices
mSelectADV1:
IF be < 1 THEN be = 1
IF be > numadv THEN be = numadv
en = be + 41: IF en > numadv THEN en = numadv
VIEW PRINT 3 TO 23: CLS 2: v = 3: h = 2
FOR x = be TO en
   LOCATE v, h: PRINT advn$(x); : v = v + 1: IF v = 24 THEN v = 3: h = 41
NEXT
c = be: RETURN
END SUB

SUB EDXMenuM (c, c1, be, en, tc1, tc2)
' // Compact version of standard Eamon Deluxe selection menu
'      Allows only a single row of choices and has no error checking
'
'  Arguments passed to EDXMenuM:
'     c - Vertical cursor position to begin at (0=CSRLIN)
'    c1 - Horizontal cursor position to begin at  (0=POS)
'    be - Location in em$ array to begin at
'    en - Location in em$ array to end
'   tc1 - Text foreground color of menu
'   tc2 - Text background color of menu
'
' Values returned by EDXMenuM:
'     c - The number of the choice relative to the amount of choices
'    c1 - This holds the exit key code (Standard:1=Enter,2=Space,3=Escape)
'    en - The actual array number of em$() that was chosen
'
'  Required SHARED variables:        (same as EDXMenu)
'
'   em$() - An array which holds all available choices.  em$(0) must
'           contain exit keys
'    em0 - The maximum dimension of the em$() array.
'
'   Upon exit, the cursor will locate to the row just beneath the last
'   choice (or 25 if it exceeds screen), at column 1
'
IF c = 0 THEN c = CSRLIN
IF c1 = 0 THEN c1 = POS(0)
v = c: v1 = c: h = c1: c = be: c1 = 0: ad = en - (en - be) - 1: COLOR tc1, tc2
FOR x = be TO en: LOCATE v, h: PRINT em$(x); : v = v + 1: NEXT

EDXMenuM:
IF c < be THEN c = en
IF c > en THEN c = be
v = c - ad + v1 - 1
LOCATE v, h: COLOR tc2, tc1: PRINT em$(c);
DO
  k$ = INKEY$
LOOP UNTIL k$ <> ""
c1 = INSTR(em$(0), RIGHT$(k$, 1)): k = ASC(RIGHT$(k$, 1))
LOCATE v, h: COLOR tc1, tc2: PRINT em$(c);

IF LEN(k$) > 1 THEN
  IF k = 71 THEN c = be
  IF k = 79 THEN c = en
  IF k = 72 OR k = 75 THEN c = c - 1
  IF k = 80 OR k = 77 THEN c = c + 1
  GOTO EDXMenuM
END IF

IF c1 = 0 THEN GOTO EDXMenuM
LOCATE en - ad + v1 - 1: PRINT : en = c: c = c - be + 1: EXIT SUB

END SUB

SUB EEdit
'
'        Edit stuff
'       ------------
c$ = "edit": CALL ESelect: IF ty = 0 THEN EXIT SUB
IF n%(ty) < 1 THEN EXIT SUB
CALL ESelectNo: nw = 0: re = no
ON ty GOTO EdRoom, EdArtifact, EdEffect, EdMonster

EdRoom:
CALL ReadDesc1
CALL ReadRoom: CALL EditRoom: CALL WriteRoom: CALL WriteDesc1: EXIT SUB

EdArtifact:
CALL ReadDesc2: CALL ReadArtifact: CALL EditArtifact: CALL WriteArtifact
CALL WriteDesc2: EXIT SUB

EdEffect:
CALL ReadDesc4: CALL EditEffect: CALL WriteDesc4: EXIT SUB

EdMonster:
CALL ReadDesc3: CALL ReadMonster: CALL EditMonster: CALL WriteMonster
CALL WriteDesc3
END SUB

SUB EList
'
'         List stuff
'        ------------
c$ = "list": CALL ESelect: IF ty = 0 THEN EXIT SUB
IF n%(ty) = 0 THEN
  PRINT : PRINT "None of that type to print!"; : CALL GetKey: EXIT SUB
END IF
CLS : l = 0
ON ty GOTO LRooms, LArtifacts, LEffects, LMonsters

LRooms:
a$ = "Listing Rooms:": GOSUB EList2: a$ = "": GOSUB EList2
FOR no = 1 TO n%(1)
   CALL ReadRoom: a$ = STR$(no) + ": " + na$: GOSUB EList2
NEXT
IF l > 0 THEN l = 99: a$ = "": GOSUB EList2
EXIT SUB

LArtifacts:
a$ = "Listing Artifacts:": GOSUB EList2: a$ = "": GOSUB EList2
FOR no = 1 TO n%(2)
   CALL ReadArtifact: a$ = STR$(no) + ": " + na$: GOSUB EList2
NEXT
IF l > 0 THEN l = 99: a$ = "": GOSUB EList2
EXIT SUB

LEffects:
a$ = "Listing Effects:": GOSUB EList2: a$ = "": GOSUB EList2
FOR no = 1 TO n%(3)
   CALL ReadDesc4: a$ = "Effect #" + STR$(no) + ":": GOSUB EList2
LEff:
   IF LEN(de$) > 79 THEN
     a$ = LEFT$(de$, 79): de$ = MID$(de$, 80): GOSUB EList2: GOTO LEff
   END IF
   a$ = de$: GOSUB EList2: a$ = "": GOSUB EList2
NEXT
IF l > 0 THEN l = 99: a$ = "": GOSUB EList2
EXIT SUB

LMonsters:
a$ = "Listing Monsters:": GOSUB EList2: a$ = "": GOSUB EList2
FOR no = 1 TO n%(4)
   CALL ReadMonster: a$ = STR$(no) + ": " + na$: GOSUB EList2
NEXT
IF l > 0 THEN l = 99: a$ = "": GOSUB EList2
EXIT SUB


EList2:
IF pt = 1 THEN LPRINT a$: RETURN
PRINT a$: l = l + 1
IF l < 22 THEN RETURN
PRINT "Hit any key..."; : CALL GetKey: l = 0: CLS : RETURN
END SUB

SUB ESelect
'
'        Select what to work on
'       ------------------------
CLS : PRINT
FOR t = 1 TO 4
   COLOR 3: PRINT t$(t); "s"; ":"; : COLOR 2: PRINT n%(t); " ";
NEXT: COLOR 3: PRINT : PRINT
PRINT "Do you want to "; c$; " a what?": PRINT

c = 0: c1 = 10
CALL EDXMenuM(c, c1, 7, 11, 3, 0)
ty = c: IF c = 5 THEN ty = 0
END SUB

SUB ESelectNo
'
'            Select number of item to work on
'           ----------------------------------
ESelectNo:
CLS : PRINT
FOR t = 1 TO 4
   COLOR 3: PRINT t$(t); "s"; ":"; : COLOR 2: PRINT n%(t); " ";
NEXT: COLOR 3
PRINT : PRINT : PRINT "Input number of "; t$(ty); " to "; c$
PRINT "   (1-"; LTRIM$(RTRIM$(STR$(n%(ty)))); : INPUT "): "; a$
CLS : no = INT(VAL(a$))
IF no < 1 OR no > n%(ty) + ABS(c$ = "create") THEN GOTO ESelectNo
END SUB

SUB ESpecial
'              Special functions
'             -------------------
Special:
CLS : COLOR 3
PRINT : PRINT "  Editing: "; : COLOR 2: PRINT aname$: PRINT : PRINT "  ";
FOR t = 1 TO 4
   COLOR 3: PRINT t$(t); "s"; ":"; : COLOR 2: PRINT n%(t); " ";
NEXT: PRINT : PRINT : PRINT

'       Adjust EDXMenuM choice string to represent printer status
em$(16) = "  5. Turn printer " + MID$("offon", ABS(pt = 0) * 3 + 1, 3) + "  "

c = 0: c1 = 6
CALL EDXMenuM(c, c1, 12, 20, 3, 0)
IF c < 1 OR c > 9 THEN GOTO Special
IF c = 9 THEN EXIT SUB

IF c >= 1 AND c < 5 AND dungeons > 1 THEN
  CLS : COLOR 14: BEEP
  PRINT "This is a multi-adventure database, you can't use that option on it!"
  COLOR 3: PRINT : PRINT "Hit any key..."; : CALL GetKey: GOTO Special
END IF

ON c GOTO SP1, SP2, SP3, SP4, SP5, SP6, SP7, SP8

'  Special 1, decrement amount of type
'
SP1:
c$ = "delete": CALL ESelect: IF ty = 0 THEN EXIT SUB
IF n%(ty) = 0 THEN GOTO Special
n%(ty) = n%(ty) - 1: up = 1: GOTO Special

'  Special 2, increment amount of type
'
SP2:
c$ = "increment": CALL ESelect: IF ty = 0 THEN EXIT SUB
IF n%(ty) = 400 AND ty <> 3 THEN GOTO Special
n%(ty) = n%(ty) + 1: up = 1: GOTO Special

' Create "Dummy" artifacts
'
SP3:
CLS : LINE INPUT "How many to generate?:"; a$: a = INT(VAL(a$))
IF a < 1 THEN GOTO Special
IF a + n%(2) > 400 THEN
 PRINT : PRINT "You can only have a maximum of 400 artifacts...";
 CALL GetKey: GOTO Special
END IF
up = 1
FOR x = 1 TO a
   n%(2) = n%(2) + 1
   na$ = "Artifact #" + LTRIM$(RTRIM$(STR$(n%(2))))
   FOR c = 1 TO 8
      a%(c) = 0
   NEXT
   de$ = "You see artifact #" + LTRIM$(RTRIM$(STR$(n%(2))))
   no = n%(2): re = no
   CALL WriteArtifact: CALL WriteDesc2
NEXT: GOTO Special

' Generate dead bodies
'
SP4:
CLS : COLOR 14: PRINT ">>>>  NOTE  <<<<": PRINT
PRINT "Before using this option make sure that you have read the DEAD BODIES"
PRINT "section of the designer manual and you are completely sure you want to"
PRINT "use dead bodies.": PRINT : COLOR 3
PRINT "Continue? (Y/N):"; : CALL GetKey: IF a$ <> "Y" THEN GOTO Special

LINE INPUT "# of monster to start with:"; a$: a = INT(VAL(a$)): PRINT
IF a < 1 OR a > n%(4) THEN GOTO Special
t = n%(4) + 1 - a
up = 1
FOR x = a TO n%(4)
   no = x
   CALL ReadMonster
   n%(2) = n%(2) + 1
   na$ = na$ + "'s body"
   FOR c = 1 TO 8: a%(c) = 0: NEXT
   a%(2) = 13: a%(3) = -999
   de$ = "You see " + na$ + "."
   no = n%(2): re = no
   CALL WriteArtifact: CALL WriteDesc2
NEXT: GOTO Special

' Toggle printer
'
SP5:
pt = ABS(pt = 0): GOTO Special

'       Specials 6-8 are reserved for future versions
'      -----------------------------------------------
SP6:
GOTO Special

SP7:
GOTO Special

SP8:
GOTO Special
END SUB

SUB GetKey
'
'           Get a single keypress w/ standard EDX twirly cursor
'          -----------------------------------------------------
bs = POS(0): CC# = 0: a$ = INKEY$
DO
   CC# = CC# + 1
   IF CC# = CC1# THEN PRINT "/": LOCATE CSRLIN - 1, bs
   IF CC# = CC2# THEN PRINT CHR$(179): LOCATE CSRLIN - 1, bs
   IF CC# = CC3# THEN PRINT "\": LOCATE CSRLIN - 1, bs: CC# = 0
   a$ = UCASE$(INKEY$)
LOOP UNTIL a$ <> ""
PRINT a$
END SUB

SUB NumInput

'        Keep input values in INTEGER range!
'       -------------------------------------
NumInput:
CALL TextInput: x = INT(VAL(I$))
IF x > 32767 THEN I$ = "32767"
IF x < -32768 THEN I$ = "-32768"
END SUB

SUB ReadArtifact
GET #2, no + adj2, ART
na$ = RTRIM$(ART.aname): a%(1) = ART.AD1: a%(2) = ART.AD2: a%(3) = ART.AD3
a%(4) = ART.AD4: a%(5) = ART.AD5: a%(6) = ART.AD6: a%(7) = ART.AD7
a%(8) = ART.AD8
END SUB

SUB ReadDesc1
GET #10, no + adj1, DS
de$ = RTRIM$(DS.TEXT)
END SUB

SUB ReadDesc2
GET #11, no + adj2, DS
de$ = RTRIM$(DS.TEXT)
END SUB

SUB ReadDesc3
GET #12, no + adj4, DS
de$ = RTRIM$(DS.TEXT)
END SUB

SUB ReadDesc4
GET #13, no + adj3, DS
de$ = RTRIM$(DS.TEXT)
END SUB

SUB ReadMonster
GET #3, no + adj4, MON
na$ = RTRIM$(MON.MNAME): m%(1) = MON.MD1: m%(2) = MON.MD2: m%(3) = MON.MD3
m%(4) = MON.MD4: m%(5) = MON.MD5: m%(6) = MON.MD6: m%(7) = MON.MD7
m%(8) = MON.MD8: m%(9) = MON.MD9: m%(10) = MON.MD10: m%(11) = MON.MD11
m%(12) = MON.MD12: m%(13) = MON.MD13
END SUB

SUB ReadRoom
GET #1, no + adj1, RM
na$ = RTRIM$(RM.RNAME): rd%(1) = RM.d1: rd%(2) = RM.d2: rd%(3) = RM.D3
rd%(4) = RM.D4: rd%(5) = RM.D5: rd%(6) = RM.D6: rd%(7) = RM.D7
rd%(8) = RM.D8: rd%(9) = RM.D9: rd%(10) = RM.D10: lt = RM.LIGHT
END SUB

SUB TextInput
'**************************************************************************
'*                   Eamon Deluxe text editor v2.2                        *
'*                        by Frank Black 1999                             *
'*                                                                        *
'*   Variables to set before calling:                                     *
'*                                                                        *
'*       tl -- The desired length of the text string                      *
'*       i$ -- The text string to edit; Can be null ("") for new strings  *
'*  columns -- The # of columns to display in  (default=80)               *
'*      clr -- The current text color (default=7)                         *
'* TextHelp -- If anything but -1, valid key info is displayed            *
'*                (Help isn't displayed for strings < 20 in length)       *
'*                                                                        *
'*   Other variables used and/or changed by this subroutine:              *
'*                                                                        *
'*         sl -- String Length                                            *
'*          i -- Current location in i$                                   *
'*  TextHelp1 -- Used to preserve TextHelp setting on strings < 20        *
'*  col & row -- Present column and row on screen                         *
'* csr1, csr2 -- Row & column loc. when called (csr2 always reverts to 1) *
'*   a, a$, x -- Generic variables for procedures                         *
'**************************************************************************
TextInput:
COLOR 6
IF columns = 0 THEN columns = 80
IF clr = 0 THEN clr = 7
TextHelp1 = TextHelp: IF tl < 20 THEN TextHelp1 = -1
csr2 = POS(0): PRINT : LOCATE CSRLIN - 1
csr1 = CSRLIN
IF csr2 + tl > columns THEN csr2 = 1
sl = LEN(I$): IF sl = 0 THEN I$ = " ": sl = 1
row = csr1: col = csr2: I = 1

LOCATE csr1, csr2: PRINT I$ + STRING$(tl - sl, 196)
IF TextHelp1 <> -1 THEN
  PRINT : PRINT "<Enter> Accepts all text left of cursor";
  IF columns < 80 THEN PRINT
  PRINT "        <Tab> Inserts a space": PRINT "  <Esc> Accepts ALL text"
  PRINT "<F1> Toggle extended text (under cursor)"
  PRINT "<F2> Toggle extended text (entire text)"
END IF

TextInput1:
LOCATE csr1, csr2: PRINT I$ + STRING$(tl - sl, 196)
'
TextInputLoop:
IF col > columns THEN col = 1: row = row + 1
IF col < 1 THEN col = columns: row = row - 1
IF row < csr1 THEN row = csr1: col = 1
IF I$ = "" THEN I$ = " ": sl = 1: I = 1
a2$ = MID$(I$, I, 1)
LOCATE row, col: COLOR 0, clr: PRINT a2$; :  COLOR clr, 0
DO
  a$ = INKEY$
LOOP UNTIL a$ <> ""
LOCATE row, col: PRINT a2$; : LOCATE row, col
'
'    Sort key presses
'
a = ASC(RIGHT$(a$, 1))
IF LEN(a$) > 1 THEN
'
'   Left and Right arrows
'
  IF a = 75 THEN
    IF I = 1 THEN GOTO ErrorRtn
    IF RIGHT$(I$, 1) = " " THEN
      I$ = LEFT$(I$, sl - 1): sl = sl - 1: PRINT CHR$(196)
    END IF
    col = col - 1: I = I - 1
    GOTO TextInputLoop
  END IF
  IF a = 77 THEN
    IF I = tl THEN GOTO ErrorRtn
    IF I = sl THEN I$ = I$ + " ": sl = sl + 1
    I = I + 1: col = col + 1
    GOTO TextInputLoop
  END IF
'
'   Up and Down arrows
'
  IF a = 72 THEN
    IF row = csr1 THEN GOTO ErrorRtn
    I$ = RTRIM$(I$): sl = LEN(I$): row = row - 1: I = I - columns
    IF I > sl THEN col = col - (I - sl): I = sl
    GOTO TextInput1
  END IF
  IF a = 80 THEN
    IF row = INT(sl / columns) + csr1 THEN GOTO ErrorRtn
    IF I + columns > sl THEN GOTO ErrorRtn
    row = row + 1: I = I + columns
    GOTO TextInput1
  END IF
'
'  <Home> & <End>
'
  IF a = 71 THEN
    IF I = 1 THEN GOTO ErrorRtn
    I$ = RTRIM$(I$): sl = LEN(I$)
    I = 1: row = csr1: col = csr2: GOTO TextInput1
  END IF
  IF a = 79 THEN
    IF I = tl THEN GOTO ErrorRtn
    x = INT(sl / columns): row = csr1 + x: col = sl - x * columns
    I = sl: GOTO TextInputLoop
  END IF
'
'   Delete
'
   IF a = 83 THEN
     IF I = sl GOTO ErrorRtn
     I$ = MID$(I$, 1, I - 1) + MID$(I$, I + 1)
     sl = sl - 1
     GOTO TextInput1
   END IF
'
'  F1 and F2  (Toggles for extened/regular ASCII mode)
'
  IF a = 59 THEN
    x = 127: IF ASC(MID$(I$, I, 1)) > 127 THEN x = -x
    I$ = LEFT$(I$, I - 1) + CHR$(ASC(MID$(I$, I, 1)) + x) + MID$(I$, I + 1)
    GOTO TextInputLoop
  END IF
  IF a = 60 THEN
    a$ = ""
    FOR a = 1 TO sl
       x = 127: IF ASC(MID$(I$, a, 1)) > 127 THEN x = -x
       a$ = a$ + CHR$(ASC(MID$(I$, a, 1)) + x)
    NEXT
    I$ = a$: GOTO TextInput1
  END IF
  GOTO ErrorRtn
END IF
'
'   Backspace
'
IF a = 8 THEN
  IF I = 1 GOTO ErrorRtn
  I$ = MID$(I$, 1, I - 2) + MID$(I$, I)
  I = I - 1: sl = sl - 1: col = col - 1
  GOTO TextInput1
END IF
'
'    TAB key (insert space)
'
IF a = 9 THEN
  IF I = tl OR I = sl OR sl = tl THEN GOTO ErrorRtn
  IF I = 1 THEN I$ = " " + I$
  IF I > 1 THEN I$ = MID$(I$, 1, I - 1) + " " + MID$(I$, I)
  sl = sl + 1: LOCATE csr1, csr2: PRINT I$;
  GOTO TextInputLoop
END IF
'
'  <ENTER> accepts text from beginning to cursor)
'    <ESC> accepts all text)
'
IF a = 13 THEN
  I$ = LEFT$(I$, I - 1 * ABS(I < tl))
  GOTO TextInputDone
END IF
IF a = 27 THEN GOTO TextInputDone
'
'  Add valid characters to string
'
IF a < 32 THEN GOTO ErrorRtn
IF I = tl THEN
  I$ = MID$(I$, 1, I - 1) + a$: PRINT a$; : GOTO TextInputLoop
END IF
IF I < sl THEN
  IF I = 1 THEN I$ = a$ + MID$(I$, 2)
  IF I > 1 THEN I$ = MID$(I$, 1, I - 1) + a$ + MID$(I$, I + 1)
END IF
IF I = sl THEN
  I$ = LEFT$(I$, sl - 1) + a$ + " ": sl = sl + 1
END IF
I = I + 1: col = col + 1: PRINT a$; : GOTO TextInputLoop
'
'     Invalide keys/move
'
ErrorRtn:
SOUND 800, .5: GOTO TextInputLoop
'
'     Display string
'
TextInputDone:
a$ = "": IF TextHelp1 <> -1 THEN a$ = STRING$(425, 32)
LOCATE csr1, csr2: PRINT STRING$(tl, 32) + a$
I$ = RTRIM$(I$): LOCATE csr1, csr2: PRINT I$: PRINT : COLOR 3
END SUB

SUB WriteArtifact
ART.aname = na$: ART.AD1 = a%(1): ART.AD2 = a%(2): ART.AD3 = a%(3)
ART.AD4 = a%(4): ART.AD5 = a%(5): ART.AD6 = a%(6): ART.AD7 = a%(7)
ART.AD8 = a%(8)
PUT #2, no + adj2, ART
END SUB

SUB WriteDesc1
DS.TEXT = de$: PUT #10, re + adj1, DS
END SUB

SUB WriteDesc2
DS.TEXT = de$: PUT #11, re + adj2, DS
END SUB

SUB WriteDesc3
DS.TEXT = de$: PUT #12, re + adj4, DS
END SUB

SUB WriteDesc4
DS.TEXT = de$: PUT #13, re + adj3, DS
END SUB

SUB WriteMonster
MON.MNAME = na$: MON.MD1 = m%(1): MON.MD2 = m%(2): MON.MD3 = m%(3)
MON.MD4 = m%(4): MON.MD5 = m%(5): MON.MD6 = m%(6): MON.MD7 = m%(7)
MON.MD8 = m%(8): MON.MD9 = m%(9): MON.MD10 = m%(10): MON.MD11 = m%(11):
MON.MD12 = m%(12): MON.MD13 = m%(13):
PUT #3, no + adj4, MON
END SUB

SUB WriteRoom
RM.RNAME = na$: RM.d1 = rd%(1): RM.d2 = rd%(2): RM.D3 = rd%(3)
RM.D4 = rd%(4): RM.D5 = rd%(5): RM.D6 = rd%(6): RM.D7 = rd%(7)
RM.D8 = rd%(8): RM.D9 = rd%(9): RM.D10 = rd%(10): RM.LIGHT = lt
PUT #1, no + adj1, RM
END SUB

